【leetcode笔记】Python实现 343. Integer Break

题目描述

Given a positive integer n, break it into the sum of at least two positive integers and maximize the product of those integers. Return the maximum product you can get.

Example 1:

Input: 2
Output: 1
Explanation: 2 = 1 + 1, 1 × 1 = 1.

Example 2:

Input: 10
Output: 36
Explanation: 10 = 3 + 3 + 4, 3 × 3 × 4 = 36.
Note: You may assume that n is not less than 2 and not larger than 58.

题目大意

一个整数可以拆分成几个较小的整数之和。求如何拆分才能使这几个较小的整数乘积最大。

解题方法

这道题给了我们一个正整数n,让我们拆分成至少两个正整数之和,使其乘积最大,题目提示中让我们用O(n)来解题,而且告诉我们找7到10之间的规律,那么我们一点一点的来分析:

正整数从1开始,但是1不能拆分成两个正整数之和,所以不能当输出。

那么2只能拆成1+1,所以乘积也为1。

数字3可以拆分成2+1或1+1+1,显然第一种拆分方法乘积大为2。

数字4拆成2+2,乘积最大,为4。

数字5拆成3+2,乘积最大,为6。

数字6拆成3+3,乘积最大,为9。

数字7拆为3+4,乘积最大,为12。

数字8拆为3+3+2,乘积最大,为18。

数字9拆为3+3+3,乘积最大,为27。

数字10拆为3+3+4,乘积最大,为36。

…

那么通过观察上面的规律,我们可以看出从5开始,数字都需要先拆出所有的3,一直拆到剩下一个数为2或者4,因为剩4就不用再拆了,拆成两个2和不拆没有意义,而且4不能拆出一个3剩一个1,这样会比拆成2+2的乘积小。那么这样我们就可以写代码了,先预处理n为2和3的情况,然后先将结果res初始化为1,然后当n大于4开始循环,我们结果自乘3,n自减3,根据之前的分析,当跳出循环时,n只能是2或者4,再乘以res返回即可。

另外:
我们应该把n拆成若干2和3的和,其中2的个数尽可能少,3的个数尽可能多。得到的所有2和3的乘积就是最大乘积。证明请参考:https://blog.csdn.net/fuxuemingzhu/article/details/80486238

代码

class Solution(object):
    def integerBreak(self, n):
        """
        :type n: int
        :rtype: int
        """
#         # 法1.归纳法
#         if n == 2: return 1
#         if n == 3: return 2
#         res = 1
#         while n > 4:
#             res *= 3
#             n -= 3
#         return res * n
        # 法2.动态规划法
        dp = [0, 0, 1, 2, 4, 6, 9]
        for i in range(7, n+1):
            dp.append(dp[i-3] * 3)
        return dp[n]

参考:https://blog.csdn.net/fuxuemingzhu/article/details/80486238

猜你喜欢

转载自blog.csdn.net/weixin_37251044/article/details/89040596